//+------------------------------------------------------------------+
//|                                               AllPivots_v2.1.mq4 |
//|                               Copyright  2006-08, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//|                                Edit by Greych, greych@rambler.ru |   
//+------------------------------------------------------------------+
#property copyright "Copyright  2006-08, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window

extern int     CountPeriods=10;
extern string  TimePeriod="D1";
extern bool    Plot_pivots=true;
extern bool    Plot_middle=false;
extern bool    Plot_camarilla=false;

   datetime time1;
   datetime time2;
   double open,close,high,low;
   double P,R1,R2,R3,R4,S1,S2,S3,S4,M0,M1,M2,M3,M4,M5,M6,M7;
   double H1,H2,H3,H4,H5,L1,L2,L3,L4,L5,CL,Range;
   double pstyle, mstyle,cstyle;
   int shift, num, period;
   string period_key;  
   void ObjDel()
   {
      for (;num<=CountPeriods;num++)
      {
      ObjectDelete("PP["+num+"]"+period_key);
      ObjectDelete("R1["+num+"]"+period_key);
      ObjectDelete("R2["+num+"]"+period_key);
      ObjectDelete("R3["+num+"]"+period_key);
      ObjectDelete("R4["+num+"]"+period_key);
      ObjectDelete("S1["+num+"]"+period_key);
      ObjectDelete("S2["+num+"]"+period_key);
      ObjectDelete("S3["+num+"]"+period_key);
      ObjectDelete("S4["+num+"]"+period_key);
      
      ObjectDelete("M0["+num+"]"+period_key);
      ObjectDelete("M1["+num+"]"+period_key);
      ObjectDelete("M2["+num+"]"+period_key);
      ObjectDelete("M3["+num+"]"+period_key);
      ObjectDelete("M4["+num+"]"+period_key);
      ObjectDelete("M5["+num+"]"+period_key);
      ObjectDelete("M6["+num+"]"+period_key);
      ObjectDelete("M7["+num+"]"+period_key);
      
      ObjectDelete("H1["+num+"]"+period_key);
      ObjectDelete("H2["+num+"]"+period_key);
      ObjectDelete("H3["+num+"]"+period_key);
      ObjectDelete("H4["+num+"]"+period_key);
      ObjectDelete("H5["+num+"]"+period_key);
      ObjectDelete("CL["+num+"]"+period_key);
      ObjectDelete("L1["+num+"]"+period_key);
      ObjectDelete("L2["+num+"]"+period_key);
      ObjectDelete("L3["+num+"]"+period_key);
      ObjectDelete("L4["+num+"]"+period_key);
      ObjectDelete("L5["+num+"]"+period_key);
      }
   }

   void PlotLine(string name,double value,double line_color,double style)
   {
   ObjectCreate(name,OBJ_TREND,0,time1,value,time2,value);
   ObjectSet(name, OBJPROP_WIDTH, 1);
   ObjectSet(name, OBJPROP_STYLE, style);
   ObjectSet(name, OBJPROP_RAY, false);
   ObjectSet(name, OBJPROP_BACK, true);
   ObjectSet(name, OBJPROP_COLOR, line_color);
    }        
int init()
  {
   if (TimePeriod=="H1" || TimePeriod=="60") {period=PERIOD_H1; period_key="H1";}
   else
   if (TimePeriod=="H4" || TimePeriod=="240") {period=PERIOD_H4; period_key="H4";}
   else
   if (TimePeriod=="D1" || TimePeriod=="1440") {period=PERIOD_D1; period_key="D1";}
   else
   if (TimePeriod=="W1" || TimePeriod=="10080") {period=PERIOD_W1; period_key="W1";}
   else
   if (TimePeriod=="MN" || TimePeriod=="43200") {period=PERIOD_MN1; period_key="MN";}
   else
   {
   Comment("Wrong TimePeriod. Must be H1, H4, D1, W1 or MN"); 
   return(0);
   }
  return(0);
  }
   
   
int deinit()
  {
   ObjDel();
   Comment("");
   return(0);
  }

int start()
  {
  int i;
     
  ObjDel();
  num=0;
  
  for (shift=CountPeriods-1;shift>=0;shift--)
  {
  time1=iTime(NULL,period,shift);
             
  high  = iHigh(NULL,period,shift+1);
  low   = iLow(NULL,period,shift+1);
  open  = iOpen(NULL,period,shift+1);
  close = iClose(NULL,period,shift+1);
  
  P  = (high+low+close)/3.0;
        
  R1 = 2*P-low;
  R2 = P+(high - low);
  R3 = (2*P)+(high-(2*low));
  R4 = P+(2*high-2*low);      
  
  S1 = 2*P-high;
  S2 = P-(high - low);
  S3 = (2*P)-((2*high)-low);
  S4 = P-(2*high-2*low);
  
  M0=0.5*(S3+S4);       
  M1=0.5*(S2+S3);
  M2=0.5*(S1+S2);
  M3=0.5*(P+S1);
  M4=0.5*(P+R1);
  M5=0.5*(R1+R2);
  M6=0.5*(R2+R3);
  M7=0.5*(R3+R4);
         
  Range = high - low;
  H5 = high/low*close;
  H4 = close + (Range * 1.1/2.0);
  H3 = close + (Range * 1.1/4.0);
  H2 = close + (Range * 1.1/6.0);
  H1 = close + (Range * 1.1/12.0);
  
  CL = close;

  L1 = close - (Range * 1.1/12.0);
  L2 = close - (Range * 1.1/6.0);
  L3 = close - (Range * 1.1/4.0);
  L4 = close - (Range * 1.1/2.0);
  L5 = close - (H5-close);
       
  time2=time1+period*60;
         
  pstyle=0;
  mstyle=3;
  cstyle=1;
  num=shift;
       
  PlotLine("PP["+num+"]"+period_key,P,Yellow,cstyle);
  if(Plot_pivots)
  {
        
   PlotLine("R1["+num+"]"+period_key,R1,Red,pstyle);
   PlotLine("R2["+num+"]"+period_key,R2,Red,pstyle);
   PlotLine("R3["+num+"]"+period_key,R3,Red,pstyle);
   PlotLine("R4["+num+"]"+period_key,R4,Red,pstyle);
               
   PlotLine("S1["+num+"]"+period_key,S1,Blue,pstyle);
   PlotLine("S2["+num+"]"+period_key,S2,Blue,pstyle);
   PlotLine("S3["+num+"]"+period_key,S3,Blue,pstyle);
   PlotLine("S4["+num+"]"+period_key,S4,Blue,pstyle);
  }
         
  if(Plot_middle)
  {
   PlotLine("M0["+num+"]"+period_key,M0,DimGray,mstyle);
   PlotLine("M1["+num+"]"+period_key,M1,DimGray,mstyle);
   PlotLine("M2["+num+"]"+period_key,M2,DimGray,mstyle);
   PlotLine("M3["+num+"]"+period_key,M3,DimGray,mstyle);
   PlotLine("M4["+num+"]"+period_key,M4,DimGray,mstyle);
   PlotLine("M5["+num+"]"+period_key,M5,DimGray,mstyle);
   PlotLine("M6["+num+"]"+period_key,M6,DimGray,mstyle);
   PlotLine("M7["+num+"]"+period_key,M7,DimGray,mstyle);
  }
         
  if(Plot_camarilla)
  {
   PlotLine("CL["+num+"]"+period_key,CL,Gold,cstyle);
   
   PlotLine("H5["+num+"]"+period_key,H5,DarkTurquoise,cstyle);
   PlotLine("H4["+num+"]"+period_key,H4,FireBrick,cstyle);
   PlotLine("H3["+num+"]"+period_key,H3,PaleGreen,cstyle);
   PlotLine("H2["+num+"]"+period_key,H2,DimGray,cstyle);
   PlotLine("H1["+num+"]"+period_key,H1,DimGray,cstyle);
      
   PlotLine("L1["+num+"]"+period_key,L1,DimGray,cstyle);
   PlotLine("L2["+num+"]"+period_key,L2,DimGray,cstyle);
   PlotLine("L3["+num+"]"+period_key,L3,PaleGreen,cstyle);
   PlotLine("L4["+num+"]"+period_key,L4,FireBrick,cstyle);
   PlotLine("L5["+num+"]"+period_key,L5,DarkTurquoise,cstyle);
  }
  }
   return(0);
  }
//+------------------------------------------------------------------+